#include <bits/stdc++.h>

using namespace std;
long long int dani[300000]={0};
long long int pojp[300000],q[300000];
int main()
{
    long long int qn,ln,l,uk=0,tp,a;
    cin>>ln>>qn;
    for(int i =0;i<ln;i++){
        cin>>l>>a;
        dani[l-1]=a;
        uk+=dani[l-1];
    }
    tp=dani[0];
    if(tp>0){
        pojp[0]=1;
        tp-=1;
    }
    else pojp[0] = 0;
    for(int i = 1;i<uk;i++){
        tp+=dani[i];
        if(tp>0){
            pojp[i]=pojp[i-1]+1;
            tp-=1;
        }
        else{
            pojp[i]=pojp[i-1];
        }
    }
    for(int i = 0;i<qn;i++){
        cin>>q[i];
    }
    for(int i = 0;i<qn;i++){
        cout<<pojp[q[i]-1];
    }
    return 0;
}